module Stackd
  autoload :Version,     'stackd/version'
  autoload :Config,      'stackd/config'
  autoload :Client,      'stackd/client'
  autoload :AuthRequest, 'stackd/auth_request'
  autoload :Token,       'stackd/token'
  autoload :Error,       'stackd/error'
  autoload :ServerError, 'stackd/server_error'

  module Util
    autoload :Portal, 'stackd/util/portal'
    autoload :HTTP,   'stackd/util/http'
  end

  module Concerns
    autoload :TattrAccessor, 'stackd/concerns/tattr_accessor'
    autoload :RequireAttr,   'stackd/concerns/require_attr'
  end

  class << self
    def config
      @config ||= Stackd::Config.new
    end

    def configure
      yield config
    end
  end
end
