module Stackd
  class Client
    include Concerns::TattrAccessor
    include Concerns::RequireAttr

    tattr_accessor id: String,
                   secret: String

    def initialize attrs
      attrs.each do |attr, val|
        public_send :"#{attr}=", val
      end

      begin
        require_attr! :id, :secret
      rescue Concerns::RequireAttr::AttrNotSetError => e
        raise ArgumentError.new e.message
      end
    end

    def auth_requests
      @auth_requests ||= Util::Portal.new self, AuthRequest
    end

    def tokens
      @tokens ||= Util::Portal.new self, Token
    end
  end
end
