require 'active_support/concern'

module Stackd
  module Concerns
    module RequireAttr
      extend ActiveSupport::Concern

      def require_attr! *attrs
        attrs.each do |key|
          if public_send(key).nil?
            raise AttrNotSetError.new "#{key} not set"
          end
        end
      end

      class AttrNotSetError < StandardError
      end
    end
  end
end
