module Stackd
  class Config
    include Concerns::TattrAccessor

    tattr_accessor auth_url: String,
                   token_url: String,
                   api_url: String

    def initialize attrs = {}
      attrs.each do |key, val|
        public_send :"#{key}=", val
      end
    end

    def auth_url
      @auth_url || "https://stackd.com/authorize"
    end

    def api_url
      @api_url || "https://api.stackd.com"
    end
  end
end
