module Stackd
  class Error < StandardError
    include Concerns::TattrAccessor
    include Concerns::RequireAttr

    tattr_accessor error: String,
                   error_description: String,
                   error_uri: String,
                   error_params: Hash

    def initialize attrs
      attrs.each do |key, val|
        public_send :"#{key}=", val if tattr? key
      end

      begin
        require_attr! :error
      rescue Concerns::RequireAttr::AttrNotSetError => e
        raise ArgumentError.new e.message
      end
    end

    def message
      error_description
    end
  end
end
